attribute vec2 aPosition;
attribute vec2 aTexCoord;
attribute float aInstance;

uniform mat4 uProjection;

#ifdef GL_ES
precision lowp float;
#endif

#define MAX_INSTANCES 40
uniform mat3 uInstancesMatrix[MAX_INSTANCES];
uniform vec4 uInstancesColor[MAX_INSTANCES];

#ifdef GL_ES
varying mediump vec2 vTextureCoord;
varying lowp vec4 vColor;
#else
varying vec2 vTextureCoord;
varying vec4 vColor;
#endif

void main(void) {
	int instance = int(aInstance); 
	vec3 instancePosition = uInstancesMatrix[instance] * vec3(aPosition, 1);
	gl_Position = uProjection * vec4(instancePosition.xy, 0.0, 1.0);
	vTextureCoord = aTexCoord;
	vColor = uInstancesColor[instance];
}
